#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityHappySummerLuckyTurnCFG.h"
std::auto_ptr<M_ActivityHappySummerLuckyTurnCFG> M_ActivityHappySummerLuckyTurnCFG::msSingleton(nullptr);

int M_ActivityHappySummerLuckyTurnCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityHappySummerLuckyTurnCFGData* M_ActivityHappySummerLuckyTurnCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityHappySummerLuckyTurnCFGData>& M_ActivityHappySummerLuckyTurnCFG::GetMapData()
{
	return mMapData;
}

void M_ActivityHappySummerLuckyTurnCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityHappySummerLuckyTurnCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityHappySummerLuckyTurnCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mItem = element->IntAttribute("Item");
		data.mCount = element->IntAttribute("Count");
		data.mWeight = element->IntAttribute("Weight");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityHappySummerLuckyTurnCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityHappySummerLuckyTurnCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityHappySummerLuckyTurnCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityHappySummerLuckyTurnCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityHappySummerLuckyTurnCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Item", data.mItem);
		LuaCfgHelper::readInt(L, "Count", data.mCount);
		LuaCfgHelper::readInt(L, "Weight", data.mWeight);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityHappySummerLuckyTurnCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityHappySummerLuckyTurnCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityHappySummerLuckyTurnCFG* M_ActivityHappySummerLuckyTurnCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityHappySummerLuckyTurnCFG());
	}
	return msSingleton.get();
}

void M_ActivityHappySummerLuckyTurnCFG::Release()
{
	msSingleton.reset(nullptr);
}
